unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, Ddidex, dddd, ddraw;

const
  MAP_AREAX: Integer = 4; //}bv\̈̃TCYi`bvPʁj
  MAP_AREAY: Integer = 4;
  CHIP_SIZE: Integer = 16;  //}bv`bṽTCYihbgPʁj
  ZOOM: Integer = 2;  //\ۂ̊g嗦

type
  TForm1 = class(TForm)
    DDDD1: TDDDD;
    DDIDEX1: TDDIDEX;
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure DDDD1Init(Sender: TObject; fNeedChange: Boolean);
    procedure DDDD1Destroy(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private 錾 }
    TmCnt: Integer; //^C}[JE^
    Map_Data : array of array of Integer; //}bṽf[^ziƂő傫w肷j
    Map_X_Size,Map_Y_Size: Integer; //}bv̏cTCYi`bvPʁj
    fx:DDBLTFX; //T[tFCX]ƂɎgf[^Ă
    SfMapChip:TDDDDSurface; //}bv`bv摜̃T[tFCX
    SfChar:TDDDDSurface; //LN^[摜̃T[tFCX
    SfMap:TDDDDSurface; //}bv\ۂ̃obNobt@T[tFCX
    VpX,VpY: Integer; //}bv\̈̍Wi[hWhbgj
    KeyFlag : String; //ꂽL[𕶎Ŋi[i:N, :S, :E, :Wj

    procedure MainLoop;
    procedure KeyCheck;
    procedure MapDraw;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

//==============================================================================
//tH[ꂽƂiɎŝĂj
procedure TForm1.FormCreate(Sender: TObject);
var
  MapFile: TFileStream; //}bvt@Cǂݍނ߂̃Xg[
  i,j: Integer; //[vJE^
begin
  MapFile := TFileStream.Create('data\map01.mpd', fmOpenRead);
  MapFile.Read(Map_X_Size, sizeof(WORD)); //}bv̏c`bvTCYĂ
  MapFile.Read(Map_Y_Size, sizeof(WORD));

  SetLength(Map_Data, Map_X_Size, Map_Y_Size);  //zmۂ
//------------------------------------------------------------------------------
//[vďԂɃ}bvf[^ݒ肵Ă
  for i := 0 to Map_Y_Size-1 do
  begin
    for j := 0 to Map_X_Size-1 do
    begin
      MapFile.Read(Map_Data[j,i], sizeof(WORD));
    end;
  end;
//------------------------------------------------------------------------------
  MapFile.Free; //YꂸɉĂII

//T[tFCX𑀍삷ƂɁAp[^KvȂ̂Őݒ肵Ă
  ZeroMemory(@fx,sizeof(DDBLTFX));
  fx.dwSize:=sizeof(DDBLTFX);

//̑ݒ
  TmCnt:=0;
  VpX:=5*CHIP_SIZE; //ŏɕ\Wݒ
  VpY:=0*CHIP_SIZE;
end;
//==============================================================================

//==============================================================================
//DDDD̏Ȉîւ̓`[gARs[Ă邾j
procedure TForm1.DDDD1Init(Sender: TObject; fNeedChange: Boolean);
begin
//------------------------------------------------------------------------------
  SfChar:=TDDDDSurface.Create(DDDD1,48,16, 0); //LN^[摜̓ǂݍ
  SfChar.LoadBMP('data\char01.bmp');
  SfChar.ColorKey:=SfChar.Pixels[1,1];
//------------------------------------------------------------------------------
  SfMapChip:=TDDDDSurface.Create(DDDD1,80,16, 0); //}bv`bv摜̓ǂݍ
  SfMapChip.LoadBMP('data\map01.bmp');
  SfMapChip.ColorKey:=SfMapChip.Pixels[0,0];
//------------------------------------------------------------------------------
  SfMap:=TDDDDSurface.Create(DDDD1,320,240, 0); //}bv\ۂ̃obNobt@
  SfMap.ColorKey:=SfMapChip.Pixels[0,0];
//------------------------------------------------------------------------------
  DDDD1.BackColor := SfMapChip.Pixels[0,0];
  DDDD1.Clear;
  DDDD1.Flip;
  DDDD1.Clear;
end;
//==============================================================================

//==============================================================================
//DDDDgIɎsiCreatêYꂸĂj
procedure TForm1.DDDD1Destroy(Sender: TObject);
begin
  SfChar.Free;
  SfMapChip.Free;
  SfMap.Free;
end;
//==============================================================================

//==============================================================================
//^C}[ŒIɎs
procedure TForm1.Timer1Timer(Sender: TObject);
begin
  MainLoop; //C[vĂяo

//------------------------------------------------------------------------------
  Inc(TmCnt); //^C~O킩悤Ƀ^C}[JEg
  if TmCnt>10 then
    TmCnt:=0;
//------------------------------------------------------------------------------
end;
//==============================================================================

//==============================================================================
//C[vi^C}[ŒIɎsj
procedure TForm1.MainLoop;
begin
  KeyCheck; //L[͂̏
  MapDraw;  //}bv\

  DDDD1.Flip; //obNobt@tgobt@ɕ\
  DDDD1.Clear;//obNobt@NA[Ă݂
end;
//==============================================================================

//==============================================================================
//L[͏
procedure TForm1.KeyCheck;
begin
  DDIDEX1.Scan(DI_KEYB);
//͂ꂽL[𕶎ƂKeyFlagɂƂ
  if DDIDEX1.Stick.X = 1 then
    KeyFlag := 'E'
  else if DDIDEX1.Stick.X = -1 then
    KeyFlag := 'W'
  else if DDIDEX1.Stick.Y = 1 then
    KeyFlag := 'S'
  else if DDIDEX1.Stick.Y = -1 then
    KeyFlag := 'N'
  else
    KeyFlag := 'NONE';
end;
//==============================================================================

//==============================================================================
//}bv`揈
procedure TForm1.MapDraw;
var
  i,j: Integer; //[vJE^
  ChipData: Integer;  //e`bṽf[^
  CpX,CpY: Integer;//`bvPʂ̓]_
  OfX,OfY: Integer;//hbgPʂ̓]_
  debugdraw : TDDDDCanvas;  //fobObZ[W\ƂɎgLoX
  VmapX,VmapY: Integer; //}bvzǂݍނ߂XY
begin

VmapX:=MAP_AREAX; //Ƃ肠A\̈̏cĂ
VmapY:=MAP_AREAY;

//XN[͂ꂽL[ɂĐݒ
if KeyFlag = 'E' then
  Inc(VpX)
else if KeyFlag = 'W' then
  Dec(VpX)
else if KeyFlag = 'N' then
  Dec(VpY)
else if KeyFlag = 'S' then
  Inc(VpY);

//z̊OǂݍނƃG[ɂȂĂ܂̂ŁA͈̓`FbN
//------------------------------------------------------------------------------
if VpX <= 0 then
  VpX :=0;
if VpX >= ((Map_X_Size*CHIP_SIZE)-(MAP_AREAX*CHIP_SIZE)) then
begin
  VmapX:=MAP_AREAX-1;
  VpX :=((Map_X_Size*CHIP_SIZE)-(MAP_AREAX*CHIP_SIZE));
end;

if VpY <= 0 then
  VpY :=0;
if VpY >= ((Map_Y_Size*CHIP_SIZE)-(MAP_AREAY*CHIP_SIZE)) then
begin
  VmapY:=MAP_AREAY-1;
  VpY :=((Map_Y_Size*CHIP_SIZE)-(MAP_AREAY*CHIP_SIZE));
end;
//------------------------------------------------------------------------------

sfMap.FillRect(Rect(0,0,320,240),sfMap.ColorMatch(clBlack)); //}bvobNobt@NA

CpX := VpX div CHIP_SIZE; //}bv\̈̍}bv`bvi`bvPʁj
OfX := VpX mod CHIP_SIZE; //}bv\̈̍}bv`bvWihbgPʁj

CpY := VpY div CHIP_SIZE;
OfY := VpY mod CHIP_SIZE;

//------------------------------------------------------------------------------
//[vŔz񂩂oāA}bvobNobt@ɓ]
  for i := 0 to VmapY do
  begin
    for j := 0 to VmapX do
    begin
      ChipData := Map_Data[j+CpX,i+CpY];

      SfMap.Blt(SfMapChip,
       Rect((j*CHIP_SIZE)-OfX,(i*CHIP_SIZE)-OfY,(j*CHIP_SIZE)+CHIP_SIZE-OfX,(i*CHIP_SIZE)+CHIP_SIZE-OfY),
       Rect(ChipData*CHIP_SIZE,0,(ChipData*CHIP_SIZE)+CHIP_SIZE,CHIP_SIZE),
       DDBLT_WAIT or DDBLT_KEYSRC,
       fx
      );

    end;
  end;
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
//}bvobNobt@tgobt@ɓ]
    SfMap.Put(
      Rect(0,0,MAP_AREAX*CHIP_SIZE*ZOOM,MAP_AREAY*CHIP_SIZE*ZOOM),
      Rect(0,0,(MAP_AREAX*CHIP_SIZE),(MAP_AREAY*CHIP_SIZE)),
      DDBLT_WAIT or DDBLT_KEYSRC,
      fx
    );

//******************************************************************************
//ʊmFpifobÔ߂ɕ\
//------------------------------------------------------------------------------
//fobOpbZ[W\
debugdraw := TDDDDCanvas.Create(SfMap); //T[tFCXKĂ݂
if not debugdraw.Enabled then
  Exit;
debugdraw.MoveTo(0,0);
debugdraw.TextOut(10,140,'VpX='+IntToStr(VpX));
debugdraw.TextOut(60,140,'VpY='+IntToStr(VpY));
debugdraw.TextOut(10,160,'KeyFlag='+KeyFlag);
debugdraw.TextOut(10,180,'CpX='+IntToStr(CpX));
debugdraw.TextOut(10,200,'TmCnt='+IntToStr(TmCnt));
debugdraw.Free;
//------------------------------------------------------------------------------
    SfMap.Put(
      Rect(320,240,320+320,240+240),
      Rect(0,0,320,240),
      DDBLT_WAIT or DDBLT_KEYSRC,
      fx
    );
//******************************************************************************

end;
//==============================================================================
end.
